import { Server } from 'socket.io'
import { TSocket } from '../../../utilities/Types'
import { Sprite } from '@prisma/client'
import SpriteRepository from '../../../repositories/SpriteRepository'

interface IPayload {}

/**
 * Handle game master list sprite event
 * @param socket
 * @param io
 */
export default function (socket: TSocket, io: Server) {
  socket.on('gm:sprite:list', async (data: any, callback: (response: Sprite[]) => void) => {
    if (socket.character?.role !== 'gm') {
      console.log(`---Character #${socket.character?.id} is not a game master.`)
      return
    }

    // get all sprites
    const sprites = await SpriteRepository.getAll()
    callback(sprites)
  })
}
